--- old/usr/src/uts/Makefile.uts	Fri Dec 21 15:01:17 2018
+++ new/usr/src/uts/Makefile.uts	Fri Dec 21 15:01:17 2018
@@ -25,6 +25,7 @@
 # Copyright (c) 2011 by Delphix. All rights reserved.
 # Copyright (c) 2013 Andrew Stormont.  All rights reserved.
 # Copyright 2016 Hans Rosenfeld <rosenfeld@grumpf.hope-2000.org>
+# Copyright (c) 2018, Joyent, Inc.
 #
 
 #
@@ -226,6 +227,15 @@
 $(RELEASE_BUILD)CERRWARN += -_gcc=-Wno-unused
 $(RELEASE_BUILD)CERRWARN += -_gcc=-Wno-empty-body
 
+CERRWARN += -_smatch=-p=illumos_kernel
+include $(SRC)/Makefile.smatch
+
+#
+# Unfortunately, _IOWR() is regularly used with a third argument of 0,
+# so we have to disable all these smatch checks.
+#
+SMOFF += sizeof
+
 CSTD = $(CSTD_GNU99)
 
 CFLAGS_uts		=
